Bug 530374 - Review Request: nitrogen - A background browser and setter for X windows
Summary: Review Request: nitrogen - A background browser and setter for X windows
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Gareth John
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2009-10-22 14:45 UTC by Sandro Mathys
Modified: 2010-05-28 18:00 UTC (History)
5 users (show)

Fixed In Version: nitrogen-1.5.1-3.fc12
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-05-28 17:59:46 UTC
gareth.l.john: fedora-review+
kevin: fedora-cvs+


Attachments (Terms of Use)

Description Sandro Mathys 2009-10-22 14:45:42 UTC
Spec URL: http://red.fedorapeople.org/SRPMS/nitrogen.spec
SRPM URL: http://red.fedorapeople.org/SRPMS/nitrogen-1.4-1.fc11.src.rpm
Description:
A background browser and setter for X windows that can be used in two
modes: browser and recall. It features Multihead and Xinerama awareness,
a recall mode to be used in startup scripts, uses the freedesktop.org
standard for thumbnails, can set the GNOME background, command line set
modes for use in scripts, inotify monitoring of browse directory, lazy
loading of thumbnails to conserve memory and an 'automatic' set mode
which determines the best mode to set an image based on its size.

$ rpmlint {SPECS,SRPMS,RPMS/i586}/nitrogen*
3 packages and 1 specfiles checked; 0 errors, 0 warnings.

Scratch builds for dist-f12 were successful on all archs:
http://koji.fedoraproject.org/koji/taskinfo?taskID=1763004

Comment 1 Ionuț Arțăriși 2009-10-23 20:41:33 UTC
Hi! I'm not a packager and so I can't approve your package yet. Just trying to help with some tips.

License: 
License of the code seems to be GPLv2, not GPLv2+.
The license of the icons is a CC by-nc-nd which is unnacceptable for fedora: https://fedoraproject.org/wiki/Licensing#Bad_Licenses_3

Missing BuildRequires(checked for by configure script): pkgconfig, gettext

Check out: https://fedoraproject.org/wiki/PackagingDrafts/ScriptletSnippets#GTK.2B_icon_cache
for updating the icon cache.

This package could probably use a .desktop file, too. It already has the icons.

Comment 2 Sandro Mathys 2009-10-23 22:30:57 UTC
Hi Ionuț,

Thanks for the tips :) Yea, I forgot the .desktop file...I recognized that soon after I uploaded the pkg but I already switched to 'lazy mode' by then ;)

Uhm...I was pretty sure I saw GPLv2+ and not GPLv2 but I'll look at it again. About the icons' licensing...didn't notice that and will try to contact upstream about it.

The missing BRs sound sane, will add them :)

Updating the icon cache...yea, right. I should patch my own rpmlint or rpmbuild or something to always yell 'DON'T FORGET DESKTOP STUFF'...I really always forget about that stuff because I wouldn't miss them myself in daily use ;)

Thanks again for those useful corrections :) You really should become a packager...you'd be the better maintainer than me with your first package already ;)

Comment 3 Sandro Mathys 2009-12-09 16:28:06 UTC
I just had a nice chat with upstream and they will ask the author of the icons regarding the license change. As it's not clear whether that will succed I'll wait to fix all the other stuff until we're ready to go.

Comment 4 Rakesh Pandit 2010-01-08 10:55:16 UTC
ping, It has been month today. Is there any update on this Sandro?

Thanks,

Comment 5 Sandro Mathys 2010-02-05 08:49:56 UTC
Spec URL: http://red.fedorapeople.org/SRPMS/nitrogen.spec
SRPM URL: http://red.fedorapeople.org/SRPMS/nitrogen-1.5.1-1.fc12.src.rpm

Apologies for the long wait, $DAYJOB kept me really busy. Upstream releases 1.5 and 1.5.1 in the meanwhile fixing the icons' licensing issue after I spoke with them. I also included the hints from Ionuț in the new spec file.

What is not clear yet to me is the licensing matter and I'd welcome any licensing expert's opinion (or if none available, I'll ask spot). While the icons are CC-BY-SA now, the code is either GPLv2 or GPLv2+ (not sure if this is stated clear enough in the sources). But the md5 code is under a different license which I'm not sure about.

Comment 6 Sandro Mathys 2010-03-02 18:11:08 UTC
Blocking FE-Legal - spot, can you please look at this piece of software and clear for me what License: I should correctly define? See comment 5 about my uncertainties. Thanks!

Comment 7 Tom "spot" Callaway 2010-03-08 21:32:47 UTC
Umm, I'm assuming you are referring to src/md5.c, which is under the zlib license.

The rest of the code is clearly marked as GPLv2+.

The license tag should be:

License: GPLv2+ and zlib and CC-BY-SA

Lifting FE-Legal.

Comment 8 Gareth John 2010-04-30 20:02:45 UTC
ping!

Comment 9 Sandro Mathys 2010-04-30 20:16:12 UTC
pong! Well, the pkg is ready for review, feel free to do it. I'll change the license in the spec file with the next version to what spot said - don't see a reason to build and upload a new version just for that right now.

Comment 10 Gareth John 2010-05-01 16:54:52 UTC
Hi Sandro,

A few final touches to may be look at for you below. 

NEEDSWORK===========================
MUST: The spec file for the package MUST be legible....NEEDSWORK
	Excesive files could glob the paths i.e 
	FROM,
		%{_datadir}/icons/hicolor/22x22/apps/nitrogen.png
		%{_datadir}/icons/hicolor/32x32/apps/nitrogen.png
		%{_datadir}/icons/hicolor/48x48/apps/nitrogen.png
	TO,
		%{_datadir}/icons/hicolor/*/apps/nitrogen.png
	
	Consider macro? 
	FROM,
		%{_datadir}/icons/hicolor/*/apps/nitrogen.png
	TO,
		%{_datadir}/icons/hicolor/*/apps/%{name}.png

MUST: Each package must consistently use macros....NEEDSWORK
	Again consider macros when usable such as %{name}.desktop

MUST: The License field in the package spec file must match the actual license....OK [NEEDSWORK AS DISCUSSED, NOT A PROBLEM]
OK ===================================
MUST: rpmlint must be run on every package. The output should be posted in the review...OK
MUST: The package must be named according to the Package Naming Guidelines....OK
MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption....OK
MUST: The package must meet the Packaging Guidelines....OK
MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines....OK (Assumed as FE-LEGAL was lifted)
MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc....OK
MUST: The spec file must be written in American English....OK
MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this....OK
MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture....OK
MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line....N/A
MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense....OK
MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden....N/A
MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun....N/A
MUST: Packages must NOT bundle copies of system libraries....OK
MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker....OK
MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory....OK
MUST: A Fedora package must not list a file more than once in the spec file's %files listings....OK
MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line....OK

MUST: The package must contain code, or permissable content....OK
MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity)....OK
MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present....OK
MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package....N/A
MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release}....N/A
MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built....N/A
MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation....OK
MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time....OK
MUST: All filenames in rpm packages must be valid UTF-8....OK

Comment 11 Gareth John 2010-05-01 17:07:38 UTC
Also change 
FROM: make install DESTDIR=$RPM_BUILD_ROOT
TO: make install DESTDIR=$RPM_BUILD_ROOT INSTALL="install -p"


https://fedoraproject.org/wiki/Packaging:Guidelines#Timestamps

Comment 12 Sandro Mathys 2010-05-01 19:25:10 UTC
Spec URL: http://red.fedorapeople.org/SRPMS/nitrogen.spec
SRPM URL: http://red.fedorapeople.org/SRPMS/nitrogen-1.5.1-2.fc12.src.rpm

Thanks for the review, John.

All NEEDSWORK done. But if I add the INSTALL thingy the build fails so I left this out.

Comment 13 Gareth John 2010-05-03 21:39:11 UTC
OK point taken, also glad to see you cleaned up man file(s).
All needswork done and looks good. 
I also had problem when using install -p.

Approved.

Comment 14 Sandro Mathys 2010-05-04 06:19:06 UTC
Great! Thanks again for the review, John!

New Package CVS Request
=======================
Package Name: nitrogen
Short Description: Background browser and setter for X windows
Owners: red
Branches: F-12 F13
InitialCC:

Comment 15 Kevin Fenzi 2010-05-06 15:21:47 UTC
CVS done (by process-cvs-requests.py).

Comment 16 Fedora Update System 2010-05-28 06:53:54 UTC
nitrogen-1.5.1-3.fc12 has been submitted as an update for Fedora 12.
http://admin.fedoraproject.org/updates/nitrogen-1.5.1-3.fc12

Comment 17 Fedora Update System 2010-05-28 06:55:12 UTC
nitrogen-1.5.1-3.fc13 has been submitted as an update for Fedora 13.
http://admin.fedoraproject.org/updates/nitrogen-1.5.1-3.fc13

Comment 18 Fedora Update System 2010-05-28 17:59:41 UTC
nitrogen-1.5.1-3.fc13 has been pushed to the Fedora 13 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 19 Fedora Update System 2010-05-28 18:00:42 UTC
nitrogen-1.5.1-3.fc12 has been pushed to the Fedora 12 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.